#include <stdio.h>
#include "pen4v3b.h"
#include "pen4v3b_str.h"

//*************************************************************
//　脚サーボ用のデータをシフトする
//　サーボデータを後ろにシフトする。（上半身の振り出し分など）
//　引数
//　　servo_wav2:モーションデータ
//　　total_data_num:シフト後のモーションデータのデータ数
//　　start_ptr:シフト量
//　　valid_data_num:シフト前のモーションデータのデータ数
//　戻り値
//　　
//*************************************************************
void wave_shift1(int servo_wav2[WAVE_MAX][12], int total_data_num,
                 int start_ptr, int valid_data_num)
{
int     i, j, ptr2;
int servo_wav_work[WAVE_MAX][12];


    //データの全コピー
    for(i = 0; i < total_data_num; i++)
    {
        for(j = 0; j < 12; j++)
        {
            servo_wav_work[i][j] = servo_wav2[i][j];
        }
    }

    //脚データについてシフトする場所より前を初期データで埋める
    for(i = 0; i < start_ptr; i++)
    {
        for(j = 0; j < 4; j++)
        {
            servo_wav_work[i][j] = servo_wav2[0][j];
        }
    }

    //実データをコピー
    ptr2 = 0;
    for(i = start_ptr; i < start_ptr + valid_data_num; i++)
    {
        for(j = 0; j < 4; j++)
        {
            servo_wav_work[i][j] = servo_wav2[ptr2][j];
        }
        ptr2++;
    }

    //脚データについてシフトする場所より後を最終データで埋める
    for(i = start_ptr + valid_data_num; i < total_data_num; i++)
    {
        for(j = 0; j < 4; j++)
        {
            servo_wav_work[i][j] = servo_wav2[valid_data_num - 1][j];
        }
    }

    //元の配列にコピーする
    //データの全コピー
    for(i = 0; i < total_data_num; i++)
    {
        for(j = 0; j < 12; j++)
        {
            servo_wav2[i][j] = servo_wav_work[i][j];
        }
    }
}
