#include <stdio.h>
#include <string.h>
#include <math.h>
#include "pen4v3b.h"
#include "pen4v3b_str.h"
#include "pen4v3b_class.h"

//*********************************************************************************
//その場旋回の最後の一歩
//足を揃える
//*********************************************************************************
int Walk02::turnL_last2(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2], struct ARM_PRM arm_prm[2], 
            struct BODY_PRM body_prm, struct STEP_INF *step_inf,double arm_ang[2][3])
{
int     i, j, k, data_num, data_num2;

double  a, q, r, dist, cx, cz, l1, l2, l3;
double  coo[100];
double  coo_wav1[2][WAVE_MAX][3];
double  angle2[WAVE_MAX][2][2];


    //変数の初期化
    for(i = 0; i < step_inf->point_num * 2 + 1; i++)
        for(k = 0; k < 2; k++) coo_wav1[k][i][1] = 0.0;

    //右足のスタート位置（後）
    coo_wav1[0][0][0] = step_inf->offset[0][0] - step_inf->travel / 2.0;
    coo_wav1[0][0][1] = step_inf->offset[0][1];
    coo_wav1[0][0][2] = step_inf->offset[0][2];

    //左足のスタート位置（前）
    coo_wav1[1][0][0] = step_inf->offset[1][0] + step_inf->travel / 2.0;
    coo_wav1[1][0][1] = step_inf->offset[1][1];
    coo_wav1[1][0][2] = step_inf->offset[1][2];

    //******************************************************************
    //右足を上げて前へ
    //移動経路長計算
    //下げる部分（1/4円弧)
    l1 = 0.25 * PI * 2.0 * step_inf->v_diff;
    //足を送る部分
    l2 = step_inf->travel / 2.0 - step_inf->v_diff;
    //足を上げる部分(1/2円弧)
    l3 = PI * step_inf->v_diff / 2.0;

    dist = l1 + l2 + l3;
    num_line_1Da(coo, dist, step_inf->point_num);

    //上げる部分（1/2円弧)
    i = 0;
    r = step_inf->v_diff / 2.0;
    cx = step_inf->offset[0][0] - step_inf->travel / 2.0;
    cz = step_inf->offset[0][2] + step_inf->v_diff / 2.0;

    while(coo[i]< l3)
    {
        q = coo[i]/ r;//円弧の中心角
        coo_wav1[0][i][0] = cx - r * sin(q);// X
        coo_wav1[0][i][2] = cz - r * cos(q);// Z
        i++;
    }

    //足を上げきった部分
    while(coo[i] < l3 + l2)
    {
        coo_wav1[0][i][0] = cx + (coo[i] - l3);// X
        coo_wav1[0][i][2] = cz + step_inf->v_diff / 2.0;// Z
        i++;
    }

    //下げる部分（1/4円弧)
    r = step_inf->v_diff;
    cx = step_inf->offset[0][0] - step_inf->v_diff;
    cz = step_inf->offset[0][2];
    while(i < step_inf->point_num)
    {
        q = (coo[i] - (l3 + l2)) / r;//円弧の中心角
        coo_wav1[0][i][0] = cx + r * sin(q);// X
        coo_wav1[0][i][2] = cz + r * cos(q);// Z
        i++;
    }
    //******************************************************************
    //左足データ作成
    dist = step_inf->travel / 2.0; 
    num_line_1Da(coo, dist, step_inf->point_num);

    //左足を接地のまま後ろへ送る部分
    i = 1;
    while(i < step_inf->point_num)
    {
        coo_wav1[1][i][0] = coo_wav1[1][0][0] - coo[i];// X
        coo_wav1[1][i][2] = coo_wav1[1][0][2];// Z
        i++;
    }

    //j = coo_fwrite("/sd/pen4.csv", coo_wav1, step_inf->point_num);
    //足先座標点列をRCサーボ出力データに変換
    i = orbit2servo_wav1(coo_wav1, angle2, &servo_wav2[0], step_inf->point_num, leg_prm);
    //サーボデータを後ろにシフトする。（頭の振り出し分）
    wave_shift1(servo_wav2, step_inf->point_num * 2, step_inf->point_num / 2, step_inf->point_num);
    //*********************************************************************************
    //踏み出す前に上半身を傾ける
    //後ろから見て反時計回りが正方向
    dist = step_inf->swingR;
    num_line_1Da(coo, dist, step_inf->point_num);

    //頭を振るデータを挿入する（行き）
    for(i = 0; i < step_inf->point_num; i++)
    {
        a = coo[i] / 180.0 * PI;
        servo_wav2[i][4] = angle2servo2(0, a, body_prm);
    }
    data_num  = step_inf->point_num;
    data_num2 = step_inf->point_num + step_inf->point_num;
    //*******************************************
    dist = - step_inf->swingR;
    num_line_1Da(coo, dist, step_inf->point_num);

    //頭を振るデータを挿入する（帰り）
    j = 0;
    for(i = data_num; i < data_num2; i++)
    {
        a = (step_inf->swingR + coo[j])  / 180.0 * PI;
        servo_wav2[i][4] = angle2servo2(0, a, body_prm);
        j++;
    }
    //*********************************************************************************
    //腕のデータを挿入する
    //腰のピッチ軸データは中立とする
    for(i = 0; i < data_num2; i++)
    {
        servo_wav2[i][5] = angle2servo2(1, 0.0, body_prm);
        k = 0;
        for(j = 6; j < 9; j++)
        {
            servo_wav2[i][j] = angle2servo3(k, arm_ang[0][k], arm_prm[0]);
            k++;
        }
        k = 0;
        for(j = 9; j < 12; j++)
        {
            servo_wav2[i][j] = angle2servo3(k, arm_ang[1][k], arm_prm[1]);
            k++;
        }
    }
    return(step_inf->point_num * 2);
}


