#include <stdio.h>
#include "pen4v3b.h"
#include "pen4v3b_str.h"

//**********************************************************
//　足先点列をＲＣサーボ出力データに変換する
//　引数
//　　coo_wav1：軌道点列
//　　angle：関節の角度
//　　q_wave：脚のモーションデータ
//　　num：モーションデータのデータ数
//　　q_wave：脚のモーションデータ
//　　leg_prm：脚用構造体
//　戻り値
//　　　０：成功
//　　－１：失敗
//**********************************************************
int orbit2servo_wav1(double coo_wav1[2][WAVE_MAX][3], double angle[WAVE_MAX][2][2],
                     int q_wave[WAVE_MAX][12], int num, struct LEG_PRM leg_prm[2])
{
int     i, j, k, l, m, n;
int     q_savo[2][2];

double  coo_work1[2][3];

    //１ポイントづつ順番に逆運動学計算関数で処理してゆく
    //足先軌道が足の届く範囲からはみ出ている時等にエラーとなる
    for(j = 0; j < num; j++)
    {
        //軌道の要素をワーク変数に退避する
        for(i = 0; i < 2; i++)
        {
            for(k = 0; k < 3; k++)coo_work1[i][k] = coo_wav1[i][j][k];
        }
        //点列－＞サーボデータ変換
        k = coo2servo(coo_work1, angle[j], q_savo, leg_prm);
        if(k != -1)
        {
            n = 0;
            for(l = 0; l < 2; l++)
            {
                for(m = 0; m < 2; m++)
                {
                    q_wave[j][n] = q_savo[l][m];
                    n++;
                }
            }
        }
        else
        {
            printf("Error! Calculation abort.(orbit2servo_wav1)\n");
            printf("Data number : %d / %d\n", j, num);
            for(l = 0; l < 2; l++)
            {
                for(m = 0; m < 3; m++)
                {
                    printf("%6.1f, ", coo_wav1[l][j][m]);
                }
                printf("\n");
            }
            return(-1);
        }
    }
    return(0);
}
