#include <stdio.h>
#include "pen4v3b.h"
#include "pen4v3b_str.h"

//**********************************************************
//　２点の座標を与えると、その間を結ぶ直線軌道を返す。
//　始点と終点では速度ゼロで戻り値－１までデータが入っている
//　引数
//　　foot_path：軌道用構造体
//　　coo_wav1：軌道点列
//　戻り値
//　　データ数
//**********************************************************
int orbit_strait1b(struct FOOT_PATH foot_path, double coo_wav1[WAVE_MAX][3])
{
int     i,j,num;
double  vx, vy, vz, dist;
double  coo_work[2][3];
double  coo[WAVE_MAX][2];

struct NUMBER_LINE number_line;

Calc_3D     calc_3d;

    //始終点のコピー(終了判定用)
    for(i = 0; i < 2; i++)
    {
        for(j = 0; j < 3; j++)
        {
            coo_work[i][j] = foot_path.coo[i][j];
        }
    }

    dist = calc_3d.dist_2points3D(coo_work);
    
    //始点と終点が一致している時の例外処理(同一座標で満たす)
    if(dist < 0.01)
    {
        for(j = 0; j < 3; j++)
        {
            coo_wav1[0][j] = foot_path.coo[0][j];
        }
        return(1);
    }

    number_line.length = dist;
    number_line.point_num = foot_path.point_num;

    //数直線の生成
    num = num_line1b(coo, number_line);

    //始点から終点へのベクトル(単位ベクトル)
    vx = (foot_path.coo[1][0] - foot_path.coo[0][0]) / dist;
    vy = (foot_path.coo[1][1] - foot_path.coo[0][1]) / dist;
    vz = (foot_path.coo[1][2] - foot_path.coo[0][2]) / dist;

    for(i = 0; i < 3; i++) coo_wav1[0][i] = foot_path.coo[0][i];
    for(i = 1; i < num; i++)
    {
          coo_wav1[i][0] = coo_wav1[i - 1][0] + coo[i][1] * vx;
          coo_wav1[i][1] = coo_wav1[i - 1][1] + coo[i][1] * vy;
          coo_wav1[i][2] = coo_wav1[i - 1][2] + coo[i][1] * vz;
    }
    return(num);
}
