struct SIO
{
    unsigned int servo_data[12];
    unsigned int gyro_data[2];
    float Battery;
};

//モーションデータのポイント数
#define  WAVE_MAX 64
//円周率
#define  PI 3.141592654

//body_prm_read.cpp
int body_prm_read(char filename0[32], struct LEG_PRM leg_prm[2]
                  , struct ARM_PRM arm_prm[2], struct BODY_PRM *body_prm);
int devide_into_field(char line[1024], char delimiter[16], char fields[32][64]);

//geo_calc.cpp
/*２次元幾何計算クラス*/
class Calc_2D
{
public:
    int crcir(double coo[2][2],double r[2]);
    double dist_2points(double coo[2][2]);
    void rotate_1D(double coo[WAVE_MAX][2], double center_x,
                double center_y, double direction, int data_num);
    double vector_dir_f(double coo[3][2]);
};

/*３次元幾何計算クラス*/
class Calc_3D
{
public:
    double dist_2points3D(double coo[2][3]);
};

//sio1.cpp
void sio_comm1(unsigned char command, struct SIO *sio);

//coo2servo.cpp に含まれている関数
int coo2servo(double coo[2][3], double angle[2][2], int q_servo[2][2], struct LEG_PRM leg_prm[2]);
int angle2servo(int joint_num, double joint_angle, struct LEG_PRM leg_prm);
int angle2servo2(int joint_num, double joint_angle, struct BODY_PRM body_prm);
int angle2servo3(int joint_num, double joint_angle, struct ARM_PRM arm_prm);

//coo2servo2.cpp に含まれている関数
int coo2servo2(double coo[2][3], double angle[2][3], int q_servo[2][3], struct ARM_PRM arm_prm[2]);

//file_IO_routines.cpp に含まれている関数
int coo_fwrite(char filename0[32], double coo_wav1[2][WAVE_MAX][3], int num);
int savo_fwrite(char filename0[32], int servo_data[WAVE_MAX][12], int num);
int savo_fread(char filename[32], int servo_data[WAVE_MAX][12]);

//number_line.cpp に含まれている関数
int num_line_1Da(double coo[WAVE_MAX], double dist, int data_num);
int num_line1b(double coo[WAVE_MAX][2], struct NUMBER_LINE number_line);

//orbit2servo_wav1.cpp に含まれている関数
int orbit2servo_wav1(double coo_wav1[2][WAVE_MAX][3], double angle[WAVE_MAX][2][2],
                     int q_wave[WAVE_MAX][12], int num, struct LEG_PRM leg_prm[2]);

//orbit_strait1b.cpp に含まれている関数
int orbit_strait1b(struct FOOT_PATH foot_path, double coo_wav1[WAVE_MAX][3]);

//Walk01_basic.cpp に含まれている関数
int wave_sit01(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2],  struct ARM_PRM arm_prm[2],
            struct BODY_PRM body_prm, struct STEP_INF step_inf, struct COG_PATH *cog_path,
            double arm_ang[2][3]);
int wave_stand01(int servo_wav2[WAVE_MAX][12], struct LEG_PRM leg_prm[2],  struct ARM_PRM arm_prm[2],
            struct BODY_PRM body_prm, struct STEP_INF step_inf, struct COG_PATH *cog_path,
            double arm_ang[2][3]);
int COG_move1(struct COG_PATH *cog_path, double coo_wav1[2][WAVE_MAX][3]);
void wave_shift1(int servo_wav2[WAVE_MAX][12], int total_data_num,
                 int start_ptr, int valid_data_num);

//create_waveset1.cpp に含まれている関数
void create_waveset1(struct BODY_PRM body_prm, struct ARM_PRM arm_prm[2],
                     struct LEG_PRM leg_prm[2]);

/*create_waveset2.cpp*/
void walk0_swingarm1(int servo_wav2[WAVE_MAX][12],  struct ARM_PRM arm_prm[2],
                 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr);
void walk0_swingarm2(int servo_wav2[WAVE_MAX][12],  struct ARM_PRM arm_prm[2],
                 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr);
void walk0_swingarm3(int servo_wav2[WAVE_MAX][12],  struct ARM_PRM arm_prm[2],
                 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr);
void walk0_swingarm4(int servo_wav2[WAVE_MAX][12],  struct ARM_PRM arm_prm[2],
                 double start_p, double target_p, int data_num1);
void walk0_swingarm5(int servo_wav2[WAVE_MAX][12],  struct ARM_PRM arm_prm[2],
                 double start_p, double target_p, int data_num1, int data_num2, int merge_ptr);
void walk0_swingarm6(int servo_wav2[WAVE_MAX][12],  struct ARM_PRM arm_prm[2],
                 double start_p, double target_p, int data_num1);

//robo_IO.cpp
void read_servo_data(int servo_data[12]);
void update_servo_data(int servo_data[12]);
void get_gyro_newtral(int gyro_newtral[2]);
void play_motion(int servo_data[WAVE_MAX][12], int data_num, int gyro_newtral[2]);
void play_motion3(char filename[32], int gyro_newtral[2]);
void gyro_test(int gyro_newtral[2]);

//remocon.cpp
void joypad_test(int gyro_newtral[2], struct LEG_PRM leg_prm[2], struct  ARM_PRM arm_prm[2], struct  BODY_PRM body_prm);



