//脚の関節パラメータ用構造体
struct LEG_PRM
{
   double   lbone_length[2];        //  各関節間の距離
   double   servo_st_en[2][6];      //  サーボ角度－出力データ対応関係の読み込み
                                    //  角度１：データ１：角度２：データ２：角度３：データ３
};

//胴体（腰など）の関節パラメータ用構造体
struct BODY_PRM
{
   double   servo_st_en[3][6];      //  サーボ角度－出力データ対応関係の読み込み
                                    //  角度１：データ１：角度２：データ２：角度３：データ３
};

//腕の関節パラメータ用構造体
struct ARM_PRM
{
   double   bone_length[3];         //  各関節間の距離
   double   servo_st_en[3][6];      //  サーボ角度－出力データ対応関係の読み込み
                                    //  角度１：データ１：角度２：データ２：角度３：データ３
};

//足先経路の保持用構造体
//始点の座標と移動ベクトルで保持する
struct COG_PATH
{
    int     point_num;          //その軌道要素のポイント数
    double  COG_coo[3];         //重心の移動量（デルタ）
    double  start_coo[2][3];    //左右の足の始点（ロボット系内座標）
};

//足先経路の保持用構造体
//始点と終点で保持する
struct FOOT_PATH
{
    int     point_num;          //構成要素点の数
    double  coo[2][3];          //始点、終点
    double  height;             //足を上げる高さ
};

//軌道の点列分解用構造体
struct NUMBER_LINE
{
    int     point_num;          //ポイント数
    double  length;             //距離
};

//モーションデータ共通パラメータ用構造体
struct STEP_INF
{
    int     point_num;          //１サイクル中のポイント数
    int     overlap_num;        //左右の足が同時に接地しているポイント数
    double  swingL;             //左右の振幅(定常歩行)
    double  swingR;             //左右の振幅(定常歩行)
    double  swing_connect;      //左右の振幅(接続点)
    double  connect_speed;      //上半身の振りの接続点の速度
    double  v_diff;             //上下の振幅
    double  init_depth;         //腰の落とし具合(歩き始め）
    double  init_offset;        //X方向のオフセット（屈伸後に発生)
    double  travel;             //歩幅
    double  offset[2][3];       //オフセット
                                //offset[0][0]  右足X
                                //offset[0][1]  左足X
                                //offset[1][0]  右足Y
                                //offset[1][1]  左足Y
                                //offset[2][0]  右足Z
                                //offset[2][1]  左足Z
};
