#include "mbed.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pen4v3b.h"
#include "pen4v3b_str.h"
#include "pen4v3b_class.h"

extern Serial h8;
extern Serial xbee;
extern Serial pc;

void joypad_test(int gyro_newtral[2], struct LEG_PRM leg_prm[2], struct  ARM_PRM arm_prm[2], struct  BODY_PRM body_prm)
{
    int     q_servo[2][2];
    int     q_servo2[2][3];
    int     servo_data_single[12];
    double  coo[2][3];
    double  coo2[2][3];
    double  angle[2][2];
    double  arm_ang[2][3];

    int     i, motion_status, waiting_flg, data_num, arm_dx, arm_dy, arm_dz;
    unsigned int ii, jj;

    struct  STEP_INF step_inf;
    int     servo_wav2[WAVE_MAX][12];

    class   Walk02 walk02;

    coo[0][0] =  -4.0;// X(右足)
    coo[0][1] =   0.0;// Y
    coo[0][2] =   3.0;// Z

    coo[1][0] =  -4.0;// X(左足)
    coo[1][1] =   0.0;// Y
    coo[1][2] =   3.0;// Z

    coo2[0][0] =   0.0;// X(右手)
    coo2[0][1] = -20.0;// Y
    coo2[0][2] =-137.0;// Z

    coo2[1][0] = - 0.0;// X(左手)
    coo2[1][1] =  20.0;// Y
    coo2[1][2] =-137.0;// Z

    //腕関節位置を初期化
    arm_ang[0][0] = -15.0 / 180.0 * PI;// SV6
    arm_ang[0][1] = -35.0 / 180.0 * PI;// SV7
    arm_ang[0][2] =  70.0 / 180.0 * PI;// SV8
    arm_ang[1][0] =  15.0 / 180.0 * PI;// SV9
    arm_ang[1][1] =  35.0 / 180.0 * PI;// SV10
    arm_ang[1][2] = -70.0 / 180.0 * PI;// SV11

    //ヒザの屈伸　歩行開始と歩行終了時のモーション生成
    //足位置のオフセットをセット
    //（左右の脚の長さに大きな誤差が合った時はここに数値を入れて調節する）
    step_inf.offset[0][0]   =  0.0;//x right
    step_inf.offset[1][0]   =  0.0;//x left
    step_inf.offset[0][1]   =  0.0;//y right
    step_inf.offset[1][1]   =  0.0;//y left
    step_inf.offset[0][2]   =  0.0;//z right
    step_inf.offset[1][2]   =  0.0;//z left

    //腰を落とす距離をセット
    step_inf.init_depth     = 3.0;
    //腰を落とした時のＸ方向（前後方向）オフセット距離をセット
    //ヒザを曲げた時にヒザ関節への負荷が変わる事により、関節の正常偏差が
    //変わり、重心が動いてしまう現象を補償するための数値をセット
    step_inf.init_offset    = 4.0;

    //足位置のオフセットをセット
    step_inf.offset[0][0]   =-step_inf.init_offset;//x right
    step_inf.offset[1][0]   =-step_inf.init_offset;//x left
    step_inf.offset[0][1]   =  0.0;//y right
    step_inf.offset[1][1]   =  0.0;//y left
    step_inf.offset[0][2]   =  step_inf.init_depth;//z right
    step_inf.offset[1][2]   =  step_inf.init_depth;//z left

    arm_dx = 0;
    arm_dy = 0;
    arm_dz = 0;

    motion_status = 1;//Stand high
    ii = 0;
    waiting_flg = 0;
    printf("Note:Start JoyPad read program on PC before activate this function.\n");
    printf("And reset 1768 to exit from this mode.\n");
    while(1) {
        //Debug
        //if(ii == 99) printf("arm_dx:%4d, arm_dy:%4d, arm_dz:%4d\n", arm_dx, arm_dy, arm_dz);
        //Receive command from the PC that have Joypad.
        if(xbee.writeable()) {
            if(waiting_flg == 0) {
                xbee.putc('A');//Joypad status request for move
                waiting_flg = 1;
                /*
                if(motion_status==1) {
                    wait_ms(20);
                }*/
            }
        }

        //Receive command from the PC that have Joypad.
        //if (xbee.readable()) {
        if (waiting_flg == 1) {
            while(!xbee.readable());
            ii = xbee.getc();
            waiting_flg = 0;
            if(ii != 0 && motion_status == 1) {
                //start to walk or continue to walk
                play_motion3("/sd/0.csv",gyro_newtral);//sit
                motion_status = 0;
            } else if(ii == 1 && (motion_status == 0 || motion_status == 2 || motion_status == 3
                                  || motion_status == 12 || motion_status == 13)) {
                //start to walk or continue to walk
                //printf("Walk\n");
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/3.csv",gyro_newtral);//first step
                    motion_status = 3;
                } else if(motion_status == 2 || motion_status == 3|| motion_status == 12 || motion_status == 13) { //first step or walking
                    play_motion3("/sd/2.csv",gyro_newtral);//walk
                    motion_status = 2;
                }
            } else if (ii == 2 && (motion_status == 0 || motion_status == 5 || motion_status == 6)) {
                //start to walk or continue to walk
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/6.csv",gyro_newtral);//first step
                    motion_status = 6;
                } else if(motion_status == 5 || motion_status == 6) { //first step or walking
                    play_motion3("/sd/5.csv",gyro_newtral);//walk
                    motion_status = 5;
                }
            } else if(ii == 3 && (motion_status == 0 || motion_status == 2 || motion_status == 3
                                  || motion_status == 12 || motion_status == 13)) {
                //start to walk or continue to walk
                //printf("Walk\n");
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/3.csv",gyro_newtral);//first step
                    motion_status = 3;
                } else if(motion_status == 2 || motion_status == 3|| motion_status == 12 || motion_status == 13) { //first step or walking
                    play_motion3("/sd/12.csv",gyro_newtral);//walk turn to the right
                    motion_status = 12;
                }
            } else if(ii == 4 && (motion_status == 0 || motion_status == 2 || motion_status == 3
                                  || motion_status == 12 || motion_status == 13)) {
                //start to walk or continue to walk
                //printf("Walk\n");
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/3.csv",gyro_newtral);//first step
                    motion_status = 3;
                } else if(motion_status == 2 || motion_status == 3|| motion_status == 12 || motion_status == 13) { //first step or walking
                    play_motion3("/sd/13.csv",gyro_newtral);//walk turn to the left
                    motion_status = 13;
                }
            } else if (ii == 5 && (motion_status == 0 || motion_status == 17 || motion_status == 18)) {
                //Turn to the left first.
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/18.csv",gyro_newtral);//first step
                    motion_status = 18;
                } else if(motion_status == 17 || motion_status == 18) { //first step or walking
                    play_motion3("/sd/17.csv",gyro_newtral);//walk
                    motion_status = 17;
                }
            } else if (ii == 6 && (motion_status == 0 || motion_status == 14 || motion_status == 15)) {
                //Turn to the right first.
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/15.csv",gyro_newtral);//first step
                    motion_status = 15;
                } else if(motion_status == 14 || motion_status == 15) { //first step or walking
                    play_motion3("/sd/14.csv",gyro_newtral);//walk
                    motion_status = 14;
                }
            } else if (ii == 7 && (motion_status == 0 || motion_status == 10)) {
                //Turn to the right.
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/10.csv",gyro_newtral);//first step
                    motion_status = 10;
                } else if(motion_status == 10) { //first step or walking
                    play_motion3("/sd/11.csv",gyro_newtral);//last step
                    motion_status = 0;
                }
            } else if (ii == 8 && (motion_status == 0 || motion_status == 8)) {
                //Turn to the left.
                if(motion_status == 0) { //sitting
                    play_motion3("/sd/8.csv",gyro_newtral);//first step
                    motion_status = 8;
                } else if(motion_status == 8) { //first step or walking
                    play_motion3("/sd/9.csv",gyro_newtral);//last step
                    motion_status = 0;
                }
            } else if ((ii == 13 || ii == 14) && (motion_status == 0 || motion_status == 20)) {
                //Tturn to the right & left little
                if(coo[0][0] <  15.0 - 4.0 && ii == 13) {
                    coo[0][0] = coo[0][0] + 1.0; // Right foot X coordinate.
                    coo[1][0] = coo[1][0] - 1.0; // Left foot X coordinate.
                }
                if(coo[0][0] > -15.0 - 4.0 && ii == 14) {
                    coo[0][0] = coo[0][0] - 1.0;
                    coo[1][0] = coo[1][0] + 1.0;
                }

                i = coo2servo(coo, angle, q_servo, leg_prm);
                //Send the result if sucsess.
                if(i == 0) {
                    //Get present positions for all the servos.
                    read_servo_data(servo_data_single);
                    //Over write the data for leg servos.
                    for(i = 0; i < 2; i++) {
                        servo_data_single[i] = q_servo[0][i];
                        servo_data_single[i+2] = q_servo[1][i];
                    }
                    update_servo_data(servo_data_single);
                }
                motion_status = 20;
            } else if (ii == 15 && motion_status == 20) {
                //信地旋回のモーション生成
                step_inf.swingL         =  16.0;
                step_inf.swingR         = -16.0;
                step_inf.v_diff         = 10.0;
                step_inf.travel         = coo[0][0] - coo[1][0];
                step_inf.overlap_num    = 0;
                step_inf.point_num      = 17;

                if(fabs(step_inf.travel) > 2) {
                    if(step_inf.travel > 0) {
                        data_num = walk02.turnR_last2(servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
                    } else {
                        step_inf.travel = step_inf.travel * -1.0;
                        data_num = walk02.turnL_last2(servo_wav2, leg_prm, arm_prm, body_prm, &step_inf, arm_ang);
                    }
                    play_motion(servo_wav2, data_num, gyro_newtral);
                }
                coo[0][0] =  -4.0;// X(右足)
                coo[1][0] =  -4.0;// X(左足)
                motion_status = 0;
            } else {
                //stop or stand
                //printf("Stop\n");
                if(ii == 0 && motion_status == 0) { //sit or last step
                    play_motion3("/sd/1.csv",gyro_newtral);//stand
                    motion_status = 1;
                } else if(ii == 99 && motion_status == 0) { //walking forward or first step

                    while(!xbee.readable());
                    jj = xbee.getc();
                    arm_dx = (int)jj - 100;
                    while(!xbee.readable());
                    jj = xbee.getc();
                    arm_dy = (int)jj - 100;
                    while(!xbee.readable());
                    jj = xbee.getc();
                    arm_dz = (int)jj - 100;
                    motion_status = 0;

                    coo2[0][0] = coo2[0][0] + (double)arm_dx / 20;// X(右手)
                    coo2[0][1] = coo2[0][1] + (double)arm_dy / 20;// Y
                    coo2[0][2] = coo2[0][2] + (double)arm_dz / 20;// Z

                    //printf("X=%6.1f, Y=%6.1f, Z=%6.1f\n",coo2[0][0], coo2[0][1], coo2[0][2]);

                    i = coo2servo2(coo2, arm_ang, q_servo2, arm_prm);
                    //Send the result if sucsess.
                    if(i == 0) {
                        //Get present positions for all the servos.
                        read_servo_data(servo_data_single);
                        //Over write the data for right arm servos.
                        servo_data_single[6] = q_servo2[0][0];
                        servo_data_single[7] = q_servo2[0][1];
                        servo_data_single[8] = q_servo2[0][2];
                        update_servo_data(servo_data_single);

                        //printf("j6=%5d, j7=%5d, j8=%5d\n",servo_data_single[6], servo_data_single[7], servo_data_single[8]);
                    }

                } else if(motion_status == 2 || motion_status == 3
                          || motion_status == 12 || motion_status == 13) { //walking forward or first step
                    play_motion3("/sd/4.csv",gyro_newtral);//last step
                    motion_status = 0;
                } else if(motion_status == 5 || motion_status == 6) { //walking backward or first step
                    play_motion3("/sd/7.csv",gyro_newtral);//last step
                    motion_status = 0;
                } else if(motion_status == 8) { //Left turn
                    play_motion3("/sd/9.csv",gyro_newtral);//last step
                    motion_status = 0;
                } else if(motion_status == 10) { //Right turn
                    play_motion3("/sd/11.csv",gyro_newtral);//last step
                    motion_status = 0;
                } else if(motion_status == 14 || motion_status == 15) { //First right turn
                    play_motion3("/sd/16.csv",gyro_newtral);//last step
                    motion_status = 0;
                } else if(motion_status == 17 || motion_status == 18) { //First left turn
                    play_motion3("/sd/19.csv",gyro_newtral);//last step
                    motion_status = 0;
                }
            }
        }
    }
}
